// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEVFSMM_FILE_INFO_H
#define _LIBGNOMEVFSMM_FILE_INFO_H

#include <glibmm.h>

/* $Id: file-info.hg,v 1.3 2003/04/30 18:25:19 murrayc Exp $ */
// -*- C++ -*- // this is for the .hg, I realize gensig puts one in

/* Copyright 2003 gnome-vfsmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomevfs/gnome-vfs-file-info.h>


namespace Gnome
{

namespace Vfs
{

/** @addtogroup libgnomevfsmmEnums Enums and Flags */

/**
 * @ingroup libgnomevfsmmEnums
 * @par Bitwise operators:
 * <tt>%FileInfoOptions operator|(FileInfoOptions, FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions operator&(FileInfoOptions, FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions operator^(FileInfoOptions, FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions operator~(FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions& operator|=(FileInfoOptions&, FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions& operator&=(FileInfoOptions&, FileInfoOptions)</tt><br>
 * <tt>%FileInfoOptions& operator^=(FileInfoOptions&, FileInfoOptions)</tt><br>
 */
enum FileInfoOptions
{
  FILE_INFO_DEFAULT = 0,
  FILE_INFO_GET_MIME_TYPE = 1 << 0,
  FILE_INFO_FORCE_FAST_MIME_TYPE = 1 << 1,
  FILE_INFO_FORCE_SLOW_MIME_TYPE = 1 << 2,
  FILE_INFO_FOLLOW_LINKS = 1 << 3,
  FILE_INFO_GET_ACCESS_RIGHTS = 1 << 4
};

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions operator|(FileInfoOptions lhs, FileInfoOptions rhs)
  { return static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) | static_cast<unsigned>(rhs)); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions operator&(FileInfoOptions lhs, FileInfoOptions rhs)
  { return static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) & static_cast<unsigned>(rhs)); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions operator^(FileInfoOptions lhs, FileInfoOptions rhs)
  { return static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) ^ static_cast<unsigned>(rhs)); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions operator~(FileInfoOptions flags)
  { return static_cast<FileInfoOptions>(~static_cast<unsigned>(flags)); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions& operator|=(FileInfoOptions& lhs, FileInfoOptions rhs)
  { return (lhs = static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) | static_cast<unsigned>(rhs))); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions& operator&=(FileInfoOptions& lhs, FileInfoOptions rhs)
  { return (lhs = static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) & static_cast<unsigned>(rhs))); }

/** @ingroup libgnomevfsmmEnums */
inline FileInfoOptions& operator^=(FileInfoOptions& lhs, FileInfoOptions rhs)
  { return (lhs = static_cast<FileInfoOptions>(static_cast<unsigned>(lhs) ^ static_cast<unsigned>(rhs))); }


class FileInfo
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef FileInfo CppObjectType;
  typedef GnomeVFSFileInfo BaseObjectType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  static Glib::RefPtr<FileInfo> create();

  // For use with Glib::RefPtr<> only.
  void reference()   const;
  void unreference() const;

  GnomeVFSFileInfo*       gobj();
  const GnomeVFSFileInfo* gobj() const;

  // The caller is responsible for freeing it. Use when directly setting fields in structs.
  GnomeVFSFileInfo* gobj_copy() const;

protected:
  // Do not derive this.  Gnome::Vfs::FileInfo can neither be constructed nor deleted.
  FileInfo();
  void operator delete(void*, size_t);

private:
  // noncopyable
  FileInfo(const FileInfo&);
  FileInfo& operator=(const FileInfo&);


public:

  
  void clear();
  
  Glib::ustring get_mime_type() const;
  
  gboolean matches(const Glib::RefPtr<const FileInfo>& b); //TODO: Use operator= - I think we have a macro for this. murrayc.

/* TODO
GList *           gnome_vfs_file_info_list_ref      (GList                  *list);
GList *           gnome_vfs_file_info_list_unref    (GList                  *list);
GList *           gnome_vfs_file_info_list_copy     (GList                  *list);
void              gnome_vfs_file_info_list_free     (GList                  *list);
*/


  std::string get_name() const;

	/* Fields which are actually valid in this structure. */
//GnomeVFSFileInfoFields valid_fields;

  GnomeVFSFileType get_type() const;

  GnomeVFSFilePermissions get_permissions() const;
  GnomeVFSFileFlags get_flags() const;

	/* These are only valid if `is_local' is TRUE (see below).  */
  //dev_t device;
  //GnomeVFSInodeNumber inode;


  guint get_link_count() const;
  guint get_uid() const;
  guint get_gid() const;
  GnomeVFSFileSize get_size() const;
  GnomeVFSFileSize get_block_count() const;
  guint get_io_block_size() const;

  //TODO: What is atime? murrayc
  time_t get_atime() const;
  time_t get_modification_time() const;
  time_t get_creation_time() const;

  std::string get_symlink_name() const;
          

};


} // namespace Vfs
} // namespace Gnome


namespace Glib
{

/** @relates Gnome::Vfs::FileInfo */
Glib::RefPtr<Gnome::Vfs::FileInfo> wrap(GnomeVFSFileInfo* object, bool take_copy = false);

} // namespace Glib

#endif /* _LIBGNOMEVFSMM_FILE_INFO_H */

